{ unit de fit des spectres 1D, 2D et 3D }
{ 100*(B-A*A)*(B-A*A)+(1-A)*(1-A) }
{ 100*exp(-sqr(X-64)/10000)*exp(-sqr(Y-64)/10000); }
{ ============================================================================= }
{ fenetre de fit de spectres 1D, 2D et 3D                                       }
{ 07.05.02 : FO : * possibilit de fitter des spectres 1D                       }
{                 * mise a jour automatique de la liste des spectres ds que le focus passe sur la fenetre de fit }
{                 * refresh automatique                                         }
{ 07.03.05:FO:* possibilit de considrer des distributions dans les fonctions de fit }
{               Attention : le nbr de distribution est limit  3!              }
{ 07.07.05:FO:* nouveau panel de fit pour les nanofils                          }
{ ============================================================================= }
{ A FAIRE                                                                       }
{ * verifier la validit de la somme circulaire !!!                             }
{   la diffrence ne fonctionne pas avec le spectre "circulaire"                }
{ * il faut pouvoir fitter sur un range dfini                                  }
{ * pouvoir choisir les paramtres a fitter                                     }
{   utiliser l'option de cochage                                                }
{ * levenberg a souvent des problmes des que la fonction est un peu complique }
{ * possibilit de sauvargerder la fonction de fit                              }
{ * afficher les valeurs intermdiaires des paramtres                          }
{ * les comboBox des spectres ne se rafraichissent pas souvent                  }
{ * faire la comparaison entre les 2 interpreteurs                              }
unit FitForm;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Parser10, Math387, ComCtrls, optimization, EditReal,
  Spin, ExtCtrls, editData, MtxVec, JvComponent, JvFormPlace, CheckLst, JvReorderListBox,
  JvCheckListBox, JvBMPListBox, Menus, MtxBaseComp, MtxVecTools, MtxDialogs,
  MtxParseExpr, MtxParseClass, MtxComCtrls, SpecialFuncs;

const
  NbrParametresNF = 7; { nombre de parametres pour les calculs nanofils           }
  NbrMaxParam = 16;
  NbrMaxPtsDistr = 99;
  Nundo = 41;
  Maxstrings = 27;
  Helpstrings: array[0..Maxstrings - 1] of string = (
    '() = brackets',
    'abs(x) = absolute value',
    'arccos(x) = inverse cosine of x in rad',
    'arccosh(x) = inverse hyperbolic cosine in rad',
    'arcsin(x) = inverse sine of x in rad',
    'arcsinh(x) = inverse hyperbolic sine in rad',
    'cos(x) = cosine of an angle in rad',
    'cosh(x) = hyperbolic cosine of an angle in rad',
    'degtorad(x) = conversion from degrees to radians',
    'exp(x) = the value of e raised to the power of x',
    'if(x1,x2,x3) = if x1=True(or 1) then x2 else x3',
    'ln(x) = natural logarithm of x',
    'log10(x) = logarithm base 10 of x',
    'logn(x1,x2) = logarithm base x1 of x2',
    'max(x1,x2) = the maximum of both arguments',
    'min(x1,x2) = the minimum of both arguments',
    'pi = 3.1415926535897932385',
    'radtodeg(x) = conversion from degrees to radians',
    'randg(x1,x2) = Draw from normal distrib. (mean=x1, sd =x2',
    'random = random number between 0 and 1',
    'round(x) = round to the nearest integer',
    'sin(x) = sine of an angle in rad',
    'sinh(x) = hyperbolic sine of an angle in rad',
    'sqr(x) = the square of a number (x*x)',
    'sqrt(x) = the square root of a number',
    'tanh(x) = the hyperbolic tangent of an angle (rad)',
    'trunc(x) = truncates a real number to an integer');
  FunctionStrings: array[0..Maxstrings - 1] of string = (
    '()', 'abs()', 'arccos()', 'arccosh()', 'arcsin()', 'arcsinh()',
    'cos()', 'cosh()', 'degtorad()', 'exp()', 'if(,,)', 'ln()', 'log10()',
    'logn(,)', 'max(,)', 'min(,)', 'pi', 'radtodeg()', 'randg(,)', 'random',
    'round()', 'sin()', 'sinh()', 'sqr()', 'sqrt()', 'tanh()', 'trunc()');

type
   vecteur=record x,y,z:double end; { vecteur tridimensionnel }

type
  TFittingForm = class(TForm)
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Label8: TLabel;
    Label10: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    helplabel: TLabel;
    Label17: TLabel;
    NEvalLabel: TLabel;
    Label18: TLabel;
    ResultEdit: TEdit;
    Evaluate: TButton;
    XEdit: TEdit;
    ExpressionEdit: TEdit;
    FunctionsCombo: TComboBox;
    Button32: TButton;
    yEdit: TEdit;
    ZEdit: TEdit;
    Button2: TButton;
    Button36: TButton;
    Button37: TButton;
    OptimizeCheck: TCheckBox;
    constantsCombo: TComboBox;
    Button3: TButton;
    EditReal1: TEditReal;
    EditReal2: TEditReal;
    EditReal3: TEditReal;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    MyFunction: TEdit;
    ChoixDim: TRadioGroup;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label7: TLabel;
    Label11: TLabel;
    ChoixSpectre2D: TComboBox;
    ChoixSpectre3D: TComboBox;
    ChoixSpectre1D: TComboBox;
    GroupBox4: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    FittingStatus: TLabel;
    Label14: TLabel;
    StopReasonBox: TLabel;
    Label20: TLabel;
    toleranceBox: TEditReal;
    IterMaxBox: TSpinEdit;
    EcartBox: TEditReal;
    DiffSpectrum: TEdit;
    MyFunctionSpectrum: TEdit;
    RadioGroup1: TRadioGroup;
    paramnumberbox: TSpinEdit;
    CheckListBox1: TCheckListBox;
    Memo1: TMemo;
    FitBouton: TButton;
    Memo2: TMemo;
    LogBox: TCheckBox;
    log: TMemo;
    CopyButton: TButton;
    StopButton: TButton;
    ProgressBar: TProgressBar;
    PlotButton: TButton;
    DistrCheckListBox: TCheckListBox;
    MemoSigma: TMemo;
    MemoNbPts: TMemo;
    MemoMult: TMemo;
    ParserFitFunction: TParser;
    JvFormPlace1: TJvFormPlace;
    MtxOpt: TMtxOptimization;
    MtxThread: TMtxProgressDialog;
    MainMenu1: TMainMenu;
    Fitting1: TMenuItem;
    Difference1: TMenuItem;
    Calculate1: TMenuItem;
    Lancerfit1: TMenuItem;
    STOP1: TMenuItem;
    Standardfunctions1: TMenuItem;
    Gaussian1D: TMenuItem;
    G1G21: TMenuItem;
    G1G2G31: TMenuItem;
    Lorentzian1D1: TMenuItem;
    xG1xL1: TMenuItem;
    Gaussian2D1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    TabSheet2: TTabSheet;
    GroupBox5: TGroupBox;
    Label24: TLabel;
    Label25: TLabel;
    IncQrBox: TEditReal;
    Disque1: TMenuItem;
    Cylindre1: TMenuItem;
    Sphere1: TMenuItem;
    IncQzBox: TEditReal;
    Label37: TLabel;
    Label38: TLabel;
    ObjectType: TRadioGroup;
    DimRadioGroup: TRadioGroup;
    Panel2: TPanel;
    DataNameBox: TEdit;
    Label39: TLabel;
    FunctionBox: TEdit;
    GroupBox9: TGroupBox;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    NbPtsQrBox: TSpinEdit;
    NbPtsQzBox: TSpinEdit;
    Label22: TLabel;
    DistrParamsCheckList: TCheckListBox;
    SigmaParams: TMemo;
    MultParams: TMemo;
    NbPtsParams: TMemo;
    Label21: TLabel;
    MemoParams: TMemo;
    Label19: TLabel;
    idlecaption: TLabel;
    PLOT1: TMenuItem;
    Plotformfactoreigenaxis1: TMenuItem;
    PlotFormFactordetectorbasis1: TMenuItem;
    PlotFQxSQ1: TMenuItem;
    GroupBox2: TGroupBox;
    Label26: TLabel;
    NbFacettesBox: TSpinEdit;
    Reflectioninsideacylinder1: TMenuItem;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    n0Box: TEditReal;
    n1Box: TEditReal;
    Plotdistributions1: TMenuItem;
    ProgressBar1: TProgressBar;
    CalcRefButton: TButton;
    Label30: TLabel;
    Thetaclabel: TLabel;
    Tmin: TEditReal;
    Tmax: TEditReal;
    Label31: TLabel;
    Label32: TLabel;
    Label23: TLabel;
    StructureFactorBox: TEdit;
    Label33: TLabel;
    TubesDensityBox: TEditReal;
    procedure CalculateDifference1Click(Sender: TObject);
    procedure UpdateCombos1Click(Sender: TObject);
    procedure Updateavailablespectra1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ChoixDimClick(Sender: TObject);
    procedure paramnumberboxChange(Sender: TObject);
    procedure FitBoutonClick(Sender: TObject);
    procedure CopyButtonClick(Sender: TObject);
    procedure LancerFit;
    procedure StopButtonClick(Sender: TObject);
    procedure Lancerfit1Click(Sender: TObject);
    procedure Difference1Click(Sender: TObject);
    procedure MtxThreadCompute(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MtxThreadProgressUpdate(Sender: TObject;
      Event: TMtxProgressEvent);
    procedure Gaussian1DClick(Sender: TObject);
    procedure Gaussian2D1Click(Sender: TObject);
    procedure Lorentzian1D1Click(Sender: TObject);
    procedure xG1xL1Click(Sender: TObject);
    procedure G1G21Click(Sender: TObject);
    procedure G1G2G31Click(Sender: TObject);
    procedure Button35Click(Sender: TObject);
    procedure ExpressionEditChange(Sender: TObject);
    procedure EvaluateClick(Sender: TObject);
    procedure Button35KeyPress(Sender: TObject; var Key: Char);
    procedure FunctionsComboChange(Sender: TObject);
    procedure XEditChange(Sender: TObject);
    procedure yEditChange(Sender: TObject);
    procedure ZEditChange(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure constantsComboClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ExpressionEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button32Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure Plotdifference1Click(Sender: TObject);
    procedure Calculate1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Disque1Click(Sender: TObject);
    procedure Cylindre1Click(Sender: TObject);
    procedure Sphere1Click(Sender: TObject);
    procedure Plotformfactoreigenaxis1Click(Sender: TObject);
    procedure PlotFormFactordetectorbasis1Click(Sender: TObject);
    procedure PlotFQxSQ1Click(Sender: TObject);
    procedure Reflectioninsideacylinder1Click(Sender: TObject);
    procedure CalcRefButtonClick(Sender: TObject);
  private
    X, Y, Z: TCplx;
    PrevText: array[0..Nundo - 1] of string;
    Iprevtext: Integer;
    istartundo: Integer;
    MyParser: TMtxExpression;
    { Private declarations }
    procedure Plot1D;
    procedure Plot2D;
    procedure PlotDiff;
    function  CalculDifference1D(ind:integer):Tsample;
    function  CalculDifference2D(ind:integer):Tsample;
    function  CalculDifference3D(ind:integer):Tsample;
    procedure MiseAjourChoixSpectres;
    procedure InitParameters;
    procedure InitParameters2;
    procedure AddToEdit(S: string);
    procedure UpdateUndo;
    procedure SetUndoText;
  public
    { Public declarations }
  end;

var
  FittingForm: TFittingForm;
  DimSpectrum,IndexSpectrum:integer;
  NbrParametres:integer;
  Pars,ParsInit, ParsVal: Array [0..NbrMaxParam] of TSample;
  methode : string;
  StopFit:boolean;
  DistrYN:Array [0..NbrMaxParam] of Boolean;  { faut-il appliquer une distribution  ce paramtre }
  sigmas:Array [0..NbrMaxParam] of TSample; { les sigmas des distributions des paramtres }
  NrPtsDistr:Array [0..NbrMaxParam] of Integer; { nombre de points dans les distributions }
  WidthDistr:Array [0..NbrMaxParam] of Integer; { largeur prise en multiple de FWHM }
  DistrX,DistrInt:Array [0..NbrMaxParam,0..NbrMaxPtsDistr] of double;
  FlagDistri:boolean;

implementation

uses MainForm, interpreteur, BoiteNoire, constants;

{$R *.dfm}

{ on met les combos a jour a chaque fois que la fenetre de fit reprend le focus }
procedure TFittingForm.FormActivate(Sender: TObject);
var i:integer;
begin
{reinitialisation des items a chaque ouverture du combo}
   MiseAjourChoixSpectres;
   choixSpectre1D.items.clear;
   for i:=1 to totalspectre do
   begin
      if und<>nil then
      if und.spect[i]<>nil then choixSpectre1D.items.add(und.spect[i].nom);
   end;
   choixSpectre2D.items.clear;
   for i:=1 to totalspectre do
   begin
      if deuxd<>nil then
      if deuxd.spect[i]<>nil then choixSpectre2D.items.add(deuxd.spect[i].nom);
   end;
   choixSpectre3D.items.clear;
   for i:=1 to totalspectre do
   begin
      if troisd<>nil then
      if troisd.spect[i]<>nil then choixSpectre3D.items.add(troisd.spect[i].nom);
   end;
end;

procedure TFittingForm.paramnumberboxChange(Sender: TObject);
var i : integer;
    j : string ;
begin
paramnumberBox.update;
{adapter le nombre de lignes dans le Memo1 au nombre de paramtres inscrit dans le champ nombre max de paramtres}
i:=CheckListBox1.Count;
while i>paramnumberbox.value do begin
                                CheckListBox1.Items.Delete(i-1);
                                memo1.Lines.Delete(i-1);
                                i:=i-1;
                                end;
i:=CheckListBox1.Count;
while i<paramnumberbox.value do begin
                                j:=Inttostr(i+1) ;
                                if i<=4
                                then CheckListBox1.Items.Insert(i,chr(65+i)) { on commence l'alphabet par 'A' }
                                else CheckListBox1.Items.Insert(i,chr(65+7+i)); { on saute les lettres aprs 'E' }
                                memo1.Lines.Insert(i,'0');
                                i:=i+1;
                                end;
end;

{stocker les valeurs introduites par l'utilisateur dans le vecteur de paramtres }
{ initiaux et dfinir les diffrents paramtres de l'optimisation}
procedure TFittingForm.InitParameters;
var i,j,k : integer;
begin
   NbrParametres:=paramnumberBox.Value;
   MiseAjourChoixSpectres;
    j:=0;
    { initialisation des valeurs des parametres }
{    for i := 0 to  paramnumberBox.Value-1 do
        begin
        if CheckListBox1.state[i]
        then begin ParamEnabled[i]:=true;ParsInit[j]:=strtofloat(memo1.Lines[i]);inc(j); end
        else ParamEnabled[i]:=false;
        end;     }
    j:=0;
    for i := 0 to  NbrParametres-1 do begin ParsInit[j]:=strtofloat(memo1.Lines[i]);inc(j);  end;
    { il faut sparer le traitement des paramtres normaux et des distributions }
    { parce qu'on se limite  seukement 3 distributions                         }
    j:=0;
    for i := 0 to  3-1 do
        begin if DistrCheckListBox.state[i]=cbChecked then DistrYN[j]:=true else DistrYN[j]:=false;
              Sigmas[j]:=strtofloat(memoSigma.Lines[i]);
              if DistrYN[j]=true then NrPtsDistr[j]:=strtoint(memoNbPts.Lines[i])
                                 else NrPtsDistr[j]:=1;
              WidthDistr[j]:=strtoInt(memoMult.Lines[i]);
              inc(j);  end;


    ParserFitFunction.expression:=MyFunction.Text;
    {initialiser le vecteur paramtre aux valeurs introduites par l'utilisateur }
    MtxOPt.VariableParameters.Length:=paramnumberbox.Value;
    For j:= 0 to  NbrParametres-1 do begin MtxOpt.VariableParameters[j]:= ParsInit[j]; end;
    MtxOpt.Iterations:= IterMaxBox.Value;
    MtxOpt.Tolerance:=toleranceBox.Value;
    DimSpectrum:=ChoixDim.itemIndex+1;
    if DimSpectrum=1 then IndexSpectrum:=und.indexof(ChoixSpectre1D.Text);
    if DimSpectrum=2 then IndexSpectrum:=deuxd.indexof(ChoixSpectre2D.Text);
    if DimSpectrum=3 then IndexSpectrum:=troisd.indexof(ChoixSpectre3D.Text);

    if LogBox.Checked then MtxOpt.Verbose := log.Lines  else MtxOpt.Verbose := nil;

    ProgressBar.Max:=IterMaxBox.value;

    flagDistri:=false;
    for k := 0 to  NbrParametres-1 do if DistrYN[k]=true then flagDistri:=true;
end;

{ stocker les valeurs introduites par l'utilisateur dans le vecteur de paramtres }
{ initiaux et dfinir les diffrents paramtres de l'optimisation               }
{ procedure  utiliser avec le Tab de culcul "nanofils"                         }
procedure TFittingForm.InitParameters2;
var i,k: integer;
begin
   { les parametres actuels sont
   1: omega
   2: chi
   3: Rayon
   4: Longueur
   5: constraste
   6: divergence
   7: longueur d'onde }
   MiseAjourChoixSpectres;

   for i := 0 to  NbrParametresNF-1 do
   begin ParsInit[i]:=strtofloat(memoParams.Lines[i]);
         { on dsactive la ligne suivante parce que le traitement de cas particuliers est trop casse gueule }
         { dans une procdure gnrale }
         {if (i=0) or (i=1) then ParsInit[i]:=ParsInit[i]*Pi/180; { passage en radians pour omega et chi }
         if DistrParamsCheckList.state[i]=cbChecked then DistrYN[i]:=true else DistrYN[i]:=false;
         Sigmas[i]:=strtofloat(SigmaParams.Lines[i]);
         NrPtsDistr[i]:=strtoint(NbPtsParams.Lines[i]);
         WidthDistr[i]:=strtoInt(MultParams.Lines[i]); end;

   flagDistri:=false;
   for k := 0 to  NbrParametresNF-1 do if DistrYN[k]=true then flagDistri:=true;
end;


{ calcul de la fonction de fit en tenant compte ou non des distributions        }
{ semble fonctionner }
procedure TFittingForm.Plot1D;
var ind,indf,indd:integer;
    i,l,m,n:integer;
    aux,ecart,fun:double;
begin
   ecart:=0;
   indf:=und.indexof(ChoixSpectre1D.text); { index du spectre qu'on veut fitter }
   ind:=und.addspectre(MyFunctionSpectrum.text,und.spect[indf].X,1,1); { index du spectre calcul }
   indd:=und.addspectre(DiffSpectrum.text,und.spect[indexSpectrum].X,1,1); { index du spectre diffrence }
   und.spect[ind].typeX:=und.spect[indf].typeX;
   if flagDistri=false
   then { pas de distribution des parametres }
   for i:=0 to und.spect[indf].X-1 do
      begin
         ParserFitFunction.X:=und.spect[indf].data[i,0,0].X;
         und.spect[ind].data[i,0,0].X:=und.spect[indf].data[i,0,0].X;
         und.spect[indd].data[i,0,0].X:=und.spect[indf].data[i,0,0].X;
         if und.spect[indf].data[i,0,0].mon<>0
         then begin und.spect[ind].data[i,0,0].Z:=ParserFitFunction.value;
                    aux:=(und.spect[indf].data[i,0,0].Z-ParserFitFunction.value);
                    und.spect[indd].data[i,0,0].Z:=aux;
                    ecart:=ecart+aux*aux; end
         else begin und.spect[ind].data[i,0,0].Z:=0;und.spect[indd].data[i,0,0].Z:=0; end;
      end
   else { prise en compte de la distribution des paramtres }
   for i:=0 to und.spect[indf].X-1 do
     begin
     fun:=0; { valeur de la fonction en tenant compte de la convolution }
     ParserFitFunction.X:=und.spect[indf].data[i,0,0].X;
     for l:=0 to NrPtsDistr[0]-1 do  { achtung, il faut que ca marche meme si NrPtsDistr[0]=0}
       for m:=0 to NrPtsDistr[1]-1 do
         for n:=0 to NrPtsDistr[2]-1 do
           begin
           ParserFitFunction.A:=DistrX[0,l];ParserFitFunction.B:=DistrX[1,m];ParserFitFunction.C:=DistrX[2,n];
           fun:=fun+ParserFitFunction.value*DistrInt[0,l]*DistrInt[1,m]*DistrInt[2,n];
           end;
     und.spect[ind].data[i,0,0].X:=und.spect[indf].data[i,0,0].X;
     und.spect[indd].data[i,0,0].X:=und.spect[indf].data[i,0,0].X;     
     if und.spect[indf].data[i,0,0].mon<>0
     then begin und.spect[ind].data[i,0,0].Z:=fun;
                aux:=(und.spect[indf].data[i,0,0].Z-fun);
                und.spect[indd].data[i,0,0].Z:=aux;
                ecart:=ecart+aux*aux; end
     else begin und.spect[ind].data[i,0,0].Z:=0;und.spect[indd].data[i,0,0].Z:=0; end;
     end;
   ecartBox.value:=ecart;
end;

{ calcul de la fonction de fit en tenant compte ou non des distributions        }
{ semble fonctionner }
procedure TFittingForm.Plot2D;
var ind,indf,indd:integer;
    i,j,l,m,n:integer;
    aux,ecart,fun:double;
begin
   ecart:=0;
   indf:=deuxd.indexof(ChoixSpectre2D.text); { index du spectre qu'on veut fitter }
   ind:=deuxd.addspectre(MyFunctionSpectrum.text,deuxd.spect[indf].X,deuxd.spect[indf].Y,1); { index du spectre calcul }
   indd:=deuxd.addspectre(DiffSpectrum.text,deuxd.spect[indf].X,deuxd.spect[indf].Y,1); { index du spectre calcul }
   deuxd.spect[ind].typeX:=deuxd.spect[indf].typeX;
   deuxd.spect[ind].typeY:=deuxd.spect[indf].typeY;
   if flagDistri=false
   then { pas de distribution des parametres }
   for i:=0 to deuxd.spect[indf].X-1 do
    for j:=0 to deuxd.spect[indf].Y-1 do
      begin
         ParserFitFunction.X:=deuxd.spect[indf].data[i,j,0].X;
         ParserFitFunction.Y:=deuxd.spect[indf].data[i,j,0].Y;
         deuxd.spect[ind].data[i,j,0].X:=deuxd.spect[indf].data[i,j,0].X;
         deuxd.spect[ind].data[i,j,0].Y:=deuxd.spect[indf].data[i,j,0].Y;
         deuxd.spect[indd].data[i,j,0].X:=deuxd.spect[indf].data[i,j,0].X;
         deuxd.spect[indd].data[i,j,0].Y:=deuxd.spect[indf].data[i,j,0].Y;
         if deuxd.spect[indf].data[i,j,0].mon<>0
         then begin deuxd.spect[ind].data[i,j,0].Z:=ParserFitFunction.value;
                    aux:=(deuxd.spect[indf].data[i,j,0].Z-ParserFitFunction.value);
                    deuxd.spect[indd].data[i,j,0].Z:=aux;
                    ecart:=ecart+aux*aux; end
         else begin deuxd.spect[ind].data[i,j,0].Z:=0;deuxd.spect[indd].data[i,j,0].Z:=0; end;
      end
   else { prise en compte de la distribution des paramtres }
   for i:=0 to deuxd.spect[indf].X-1 do
    for j:=0 to deuxd.spect[indf].Y-1 do
     begin
     fun:=0; { valeur de la fonction en tenant compte de la convolution }
     ParserFitFunction.X:=deuxd.spect[indf].data[i,j,0].X;
     ParserFitFunction.Y:=deuxd.spect[indf].data[i,j,0].Y;
     for l:=0 to NrPtsDistr[0]-1 do  { achtung, il faut que ca marche meme si NrPtsDistr[0]=0}
       for m:=0 to NrPtsDistr[1]-1 do
         for n:=0 to NrPtsDistr[2]-1 do
           begin
           ParserFitFunction.A:=DistrX[0,l];ParserFitFunction.B:=DistrX[1,m];ParserFitFunction.C:=DistrX[2,n];
           fun:=fun+ParserFitFunction.value*DistrInt[0,l]*DistrInt[1,m]*DistrInt[2,n];
           end;
     deuxd.spect[ind].data[i,j,0].X:=deuxd.spect[indf].data[i,j,0].X;
     deuxd.spect[ind].data[i,j,0].Y:=deuxd.spect[indf].data[i,j,0].Y;
     deuxd.spect[indd].data[i,j,0].X:=deuxd.spect[indf].data[i,j,0].X;
     deuxd.spect[indd].data[i,j,0].Y:=deuxd.spect[indf].data[i,j,0].Y;
     if deuxd.spect[indf].data[i,j,0].mon<>0
     then begin deuxd.spect[ind].data[i,j,0].Z:=fun;
                aux:=(deuxd.spect[indf].data[i,j,0].Z-fun);
                deuxd.spect[indd].data[i,j,0].Z:=aux;
                ecart:=ecart+aux*aux; end
     else begin deuxd.spect[ind].data[i,j,0].Z:=0;deuxd.spect[indd].data[i,j,0].Z:=0; end;
     end;
   ecartBox.value:=ecart;
end;

procedure TFittingForm.PlotDiff;
begin
   case dimSpectrum of
     1:begin plot1D; end;
     2:begin plot2D; end;
   end;
end;

{ creation des distribtutions }
procedure GenerateDistributions(ParsInit: Array of TSample);
var i,j,k,nbr,mult:integer;
    sig,delta,totalIntensity:double;
begin
   { generation d'un spectre en Qz pour des data mesures en Fixed WL }
   for k := 0 to  NbrParametres-1 do
   if DistrYN[k]=true
   then begin { il faut que ca marche avec NrPtsDistr[k]=1 }
        Nbr:=trunc(NrPtsDistr[k]/2); { 1/2 nbr de points  prendre en compte }
        sig:=sigmas[k]/2; { HWHM }
        Mult:=WidthDistr[k]; { largeur  prendre ne compte en multiple de HWHM }
        for i:=0 to NrPtsDistr[k]-1 do
        begin
           TotalIntensity:=0;
           delta:=Mult*sig*sqrt(2*ln(2))/Nbr; { step dans la distribution }
           for j:=-Nbr to Nbr do { cration de la distribution proprement dire }
           begin
              DistrX[k,j+Nbr]:=ParsInit[k]+j*delta;
              DistrInt[k,j+Nbr]:=1/(sig*sqrt(2*pi))*exp(-(sqr(j*delta)/(2*sig*sig)));
              TotalIntensity:=TotalIntensity+DistrInt[k,j+Nbr];  end;
           { renormalisation des intensits }
           for j:=-Nbr to Nbr do DistrInt[k,j+Nbr]:=DistrInt[k,j+Nbr]/TotalIntensity;
        end;
        end
    else begin DistrX[k,0]:=ParsInit[k];DistrInt[k,0]:=1; end;
end;

{ creation des distribtutions pour la fiche de calcul 2 (spheres, disques, cylindres) }
procedure GenerateDistributions2(ParsInit: Array of TSample);
var i,j,k,nbr,mult:integer;
    sig,delta,totalIntensity:double;
begin
   { generation d'un spectre en Qz pour des data mesures en Fixed WL }
   for k := 0 to  NbrParametresNF-1 do
   if DistrYN[k]=true
   then begin { il faut que ca marche avec NrPtsDistr[k]=1 }
        Nbr:=trunc(NrPtsDistr[k]/2); { 1/2 nbr de points  prendre en compte }
        sig:=sigmas[k]/2; { HWHM }
        Mult:=WidthDistr[k]; { largeur  prendre ne compte en multiple de HWHM }
        for i:=0 to NrPtsDistr[k]-1 do
        begin
           TotalIntensity:=0;
           delta:=Mult*sig*sqrt(2*ln(2))/Nbr; { step dans la distribution }
           for j:=-Nbr to Nbr do { cration de la distribution proprement dire }
           begin
              DistrX[k,j+Nbr]:=ParsInit[k]+j*delta;
              DistrInt[k,j+Nbr]:=1/(sig*sqrt(2*pi))*exp(-(sqr(j*delta)/(2*sig*sig)));
              TotalIntensity:=TotalIntensity+DistrInt[k,j+Nbr];  end;
           { renormalisation des intensits }
           for j:=-Nbr to Nbr do DistrInt[k,j+Nbr]:=DistrInt[k,j+Nbr]/TotalIntensity;
        end;
        end
    else begin DistrX[k,0]:=ParsInit[k];DistrInt[k,0]:=1;NrPtsDistr[k]:=1 end;
end;

{ INPUT : ind, index du spectre 1D a fitter }
function TFittingForm.CalculDifference1D(ind:integer):Tsample;
var i,l,m,n:integer;
    aux,ecart,fun:double;
begin
   ecart:=0;
   if flagDistri=false
   then { pas de distribution des parametres }
   for i:=0 to und.spect[ind].X-1 do
      begin
         ParserFitFunction.X:=und.spect[ind].data[i,0,0].X;
         if (und.spect[ind].data[i,0,0].mon<>0)
         then begin aux:=(und.spect[ind].data[i,0,0].Z-ParserFitFunction.value);
                    ecart:=ecart+aux*aux; end;
      end
   else { prise en compte de la distribution des paramtres }
   for i:=0 to und.spect[ind].X-1 do
     begin
     fun:=0;
     ParserFitFunction.X:=und.spect[ind].data[i,0,0].X;
     for l:=0 to NrPtsDistr[0]-1 do  { achtung, il faut que ca marche meme si NrPtsDistr[0]=0}
       for m:=0 to NrPtsDistr[1]-1 do
         for n:=0 to NrPtsDistr[2]-1 do
           begin
           ParserFitFunction.A:=DistrX[0,l];ParserFitFunction.B:=DistrX[1,m];ParserFitFunction.C:=DistrX[2,n];
           fun:=fun+ParserFitFunction.value*DistrInt[0,l]*DistrInt[1,m]*DistrInt[2,n];
           end;
     if (und.spect[ind].data[i,0,0].mon<>0)
     then begin aux:=(und.spect[ind].data[i,0,0].Z-fun);
                ecart:=ecart+aux*aux; end;
     end;
   result:=ecart;
end;

{ INPUT : ind, index du spectre 2D a fitter }
function TFittingForm.CalculDifference2D(ind:integer):Tsample;
var i,j,l,m,n:integer;
    aux,ecart,fun:double;
begin
   ecart:=0;
   if flagDistri=false
   then { pas de distribution des parametres }
   for i:=0 to deuxd.spect[ind].X-1 do
    for j:=0 to deuxd.spect[ind].Y-1 do
      begin
         ParserFitFunction.X:=deuxd.spect[ind].data[i,j,0].X;
         ParserFitFunction.Y:=deuxd.spect[ind].data[i,j,0].Y;
         if (deuxd.spect[ind].data[i,j,0].mon<>0)
         then begin aux:=(deuxd.spect[ind].data[i,j,0].Z-ParserFitFunction.value);
                    ecart:=ecart+aux*aux; end;
      end
   else { prise en compte de la distribution des paramtres }
   for i:=0 to deuxd.spect[ind].X-1 do
    for j:=0 to deuxd.spect[ind].Y-1 do
     begin
     fun:=0;
     ParserFitFunction.X:=deuxd.spect[ind].data[i,j,0].X;
     ParserFitFunction.Y:=deuxd.spect[ind].data[i,j,0].Y;
     for l:=0 to NrPtsDistr[0]-1 do  { achtung, il faut que ca marche meme si NrPtsDistr[0]=0}
       for m:=0 to NrPtsDistr[1]-1 do
         for n:=0 to NrPtsDistr[2]-1 do
           begin
           ParserFitFunction.A:=DistrX[0,l];ParserFitFunction.B:=DistrX[1,m];ParserFitFunction.C:=DistrX[2,n];
           fun:=fun+ParserFitFunction.value*DistrInt[0,l]*DistrInt[1,m]*DistrInt[2,n];
           end;

     if (deuxd.spect[ind].data[i,j,0].mon<>0)
     then begin aux:=(deuxd.spect[ind].data[i,j,0].Z-fun);
                ecart:=ecart+aux*aux; end;
     end;
   result:=ecart;
end;

{ INPUT : ind, index du spectre 3D a fitter }
function TFittingForm.CalculDifference3D(ind:integer):Tsample;
var i,j,k:integer;
    aux,ecart:double;
begin
end;

function Banana(ParsInit: Array of TSample; Const Consts : Array of TSample ; Const  PConsts: Array of Pointer): TSample;
{dfinir la fonction  fitter}
var i : integer ;
begin
   if flagDistri=true then GenerateDistributions(ParsInit);
   with FittingForm do
   begin
   ParserFitFunction.expression:=MyFunction.Text;
   i:= NbrParametres;
   if i > 0 then ParserFitFunction.A:=ParsInit[0];
   if i > 1 then ParserFitFunction.B:=ParsInit[1];
   if i > 2 then ParserFitFunction.C:=parsInit[2];
   if i > 3 then ParserFitFunction.D:=parsInit[3];
   if i > 4 then ParserFitFunction.E:=parsInit[4];
   if i > 5 then ParserFitFunction.M:=parsInit[5];
   if i > 6 then ParserFitFunction.N:=ParsInit[6];
   if i > 7 then ParserFitFunction.O:=ParsInit[7];
   if i > 8 then ParserFitFunction.P:=parsInit[8];
   if i > 9 then ParserFitFunction.Q:=parsInit[9];
   if i > 10 then ParserFitFunction.R:=parsInit[10];
   if i > 11 then ParserFitFunction.S:=parsInit[11];
   if i > 12 then ParserFitFunction.T:=parsInit[12];
   if i > 13 then ParserFitFunction.U:=parsInit[13];
   if i > 14 then ParserFitFunction.V:=parsInit[14];
   if i > 15 then ParserFitFunction.W:=parsInit[15];
   { X, Y, Z sont rserves pour les paramtres des spectres }
    case dimSpectrum of
      1:result:= CalculDifference1D(indexSpectrum);
      2:result:= CalculDifference2D(indexSpectrum);
      3:result:= CalculDifference3D(indexSpectrum);
    end;
   end;
end;


{ mise a jour de la combo ChoixSpectre  partir de la liste des spectres 2D }
{ INPUT: la liste de spectres "deuxd" en gnral                            }
{        a passer en var parce que la taille risque de devenir gigantesque  }
procedure TFittingForm.MiseAjourChoixSpectres;
var i:integer;
begin
{reinitialisation des items a chaque ouverture du combo}
   choixSpectre1D.items.clear;choixSpectre2D.items.clear;choixSpectre3D.items.clear;
   for i:=1 to totalspectre do
   begin
      if und.spect[i]<>nil    then choixSpectre1D.items.add(und.spect[i].nom);
      if deuxd.spect[i]<>nil  then choixSpectre2D.items.add(deuxd.spect[i].nom);
      if troisd.spect[i]<>nil then choixSpectre3D.items.add(troisd.spect[i].nom);
   end;
   case ChoixDim.itemIndex of
      0:begin choixSpectre1D.enabled:=true;choixSpectre2D.enabled:=false;choixSpectre3D.enabled:=false; end;
      1:begin choixSpectre1D.enabled:=false;choixSpectre2D.enabled:=true;choixSpectre3D.enabled:=false; end;
      2:begin choixSpectre1D.enabled:=false;choixSpectre2D.enabled:=false;choixSpectre3D.enabled:=true; end;
   end;
end;

procedure TFittingForm.CalculateDifference1Click(Sender: TObject);
begin
  InitParameters;
  EcartBox.Value:=banana(parsInit,[],[]);
  PlotDiff;
  { update des diffrents graphs }
  sendmessage(principalform.handle,wm_redessine,0,0);
end;

procedure TFittingForm.UpdateCombos1Click(Sender: TObject);
begin
   MiseAjourChoixSpectres
end;

procedure TFittingForm.Updateavailablespectra1Click(Sender: TObject);
begin
   MiseAjourChoixSpectres
end;

procedure TFittingForm.FormCreate(Sender: TObject);
var S: string;
    I, J: Integer;
begin
  WindowState:=wsMinimized;
  left:=0;top:=0;width:=666;height:=400;

  inherited;
  MyParser := TMtxExpression.Create;
  MyParser.DefineVariableCplx('x', @X);
  MyParser.DefineVariableCplx('y', @Y);
  MyParser.DefineVariableCplx('z', @Z);
  X := StrToCplx(XEdit.Text);
  Y := StrToCplx(yEdit.Text);
  Z := StrToCplx(ZEdit.Text);
  FunctionsCombo.ItemIndex := 0;
  Iprevtext := -1;
  istartundo := -1;
  FunctionsCombo.Clear;
  for I := 0 to Maxstrings - 1 do
  begin
    S := Functionstrings[I];
    if MyParser.Separator <> ',' then
    repeat
        J := Pos(',', S);
        if J > 0 then S[J] := MyParser.Separator;
    until J = 0;
//    FunctionsCombo.Items.Add(S);
  end;
  for i := 0 to MyParser.WordsCount-1 do
  begin
        if (MyParser.Word(i) is TDoubleConstant) then ConstantsCombo.Items.Add(MyParser.Word(i).Name) else
        if ((MyParser.Word(i) is TFunction) or
           (MyParser.Word(i) is TBooleanFunction) or
           (MyParser.Word(i) is TVaryingFunction)) then FunctionsCombo.Items.Add(MyParser.Word(i).Name);
  end;
  MyParser.OnChange := ExpressionEditChange;
end;


procedure TFittingForm.ChoixDimClick(Sender: TObject);
begin
   MiseAjourChoixSpectres
end;



procedure TFittingForm.LancerFit;
{lancer le fit}
var tmpStr:string;
    i,debut,j: integer;
    temp : Tsample ;
    tempst,s : string;
begin
{  MtxThread.InfiniteLoop := False; { on est limit aux nombre max d'itrations }
{  MtxThread.InternalLoop := True;  { on ne peut pas intervenir dans le fit     }
{  MtxThread.ShowDialog := false;
{  MtxThread.DefineLoop(0,1500);
{  MtxThread.start;   }

   j:=0;
   Log.Lines.Clear;
   {boitnoir.receivetext('Parameters given by '+ methode + ' are');   }
   FittingStatus.caption:='Fitting in progress';FittingStatus.update;
   MtxOPt.RealFunction:=banana;
   MtxOPt.dirty:=true;
   MtxOPt.minvalue:=0;
   MtxOPt.VariableParameters.Length:=paramnumberbox.Value;
   {choix de la mthode d'optimisation}
   case RadioGroup1.itemIndex of
     0:begin MtxOpt.OptimizationMethod := optSimplex; methode := 'Simplex'  end;
     1:begin MtxOpt.OptimizationMethod := optBFGS ; methode := 'BFGS' end;
     2:begin MtxOpt.OptimizationMethod := optMarquardt; methode := 'Marquart' end;
     3:begin MtxOpt.OptimizationMethod := optDFP; methode := 'DFP' end;
   end;

{    MtxOpt.Tolerance:=ToleranceBox.Value;
    MtxOpt.MaxIterations := IterMaxBox.value ;
    MtxOpt.Recalculate;        }
   { lancement du fit proprement dit }
    for i:=1 to 10 do
    begin
       MtxOpt.MaxIterations:=round(IterMaxBox.value/10);
       MtxOpt.Recalculate;
       ProgressBar.Position:=i*10;
       Application.processMessages;
       if StopFit then Break;
    end;

  case MtxOpt.StopReason of
  { affichage de la Stop Reason}
    OptResConverged : tmpStr := tmpStr + 'Converged';
    OptResMaxIter : tmpStr := tmpStr + 'Iterations > Max. Iterations';
    OptResSmallStep : tmpStr := tmpStr + 'X step < Tolerance';
    OptResZeroStep : tmpStr := tmpStr + 'Zero x step';
    OptResSmallGrad : tmpStr := tmpStr + 'C Norm(Grad) < gradient tolerance';
    OptResBigLambda : tmpStr := tmpStr + 'Big Lambda';
  end;
  stopReasonBox.caption:=tmpStr;
  EcartBox.value:=MtxOpt.MinValue;
  FittingStatus.caption:='Idle';FittingStatus.update;
   {affichage de la valeur finale des paramtres fitts dans le memo2}
   debut:=Memo2.lines.count;
   Memo2.Lines.Insert(debut,'Parameters given by '+ methode);
   s:='';
   for i:=debut+1 to paramnumberbox.Value+debut do
                         begin
                         temp:= MtxOpt.VariableParameters.values[j];
                         tempst:= FloatToStrF(temp,ffGeneral, 18, 2);
                         s:=s+tempst+#9;
                         Memo2.Lines.Insert(i,tempst);
                         inc(j);
                         end;

   boitnoir.receivetext(s+#9+tmpStr);
   PlotDiff;sendmessage(principalform.handle,wm_redessine,0,0);
end;

procedure TFittingForm.FitBoutonClick(Sender: TObject);
{lancer le fit}
begin
   InitParameters;
   stopFit:=false;
   LancerFit;
end;

procedure TFittingForm.CopyButtonClick(Sender: TObject);
var i : integer;
    temp : Tsample ;
    tempst : string;
begin
Memo1.Lines.Clear;
for i:=0  to paramnumberbox.Value-1 do
                         begin
                         temp:= MtxOpt.VariableParameters.values[i];
                         tempst:= FloatToStrF(temp,fffixed, 18, 4);
                         Memo1.Lines.Insert(i,tempst);
                         end;
end;

procedure TFittingForm.StopButtonClick(Sender: TObject);
begin
  StopFit := True;
end;


procedure TFittingForm.Lancerfit1Click(Sender: TObject);
begin
   InitParameters;
   LancerFit;
end;

procedure TFittingForm.Difference1Click(Sender: TObject);
begin
  InitParameters;
  EcartBox.Value:=banana(parsInit,[],[]);
  PlotDiff;
  { update des diffrents graphs }
  sendmessage(principalform.handle,wm_redessine,0,0);
end;

{ lancement threaded de la procedure de fit }
procedure TFittingForm.MtxThreadCompute(Sender: TObject);
begin
   InitParameters;
   LancerFit;
end;

procedure TFittingForm.Button1Click(Sender: TObject);
begin
  MtxThread.InfiniteLoop := False; { on est limit aux nombre max d'itrations }
  MtxThread.InternalLoop := True;  { on ne peut pas intervenir dans le fit     }
  MtxThread.ShowDialog := false;
  MtxThread.DefineLoop(0,1500);
  MtxThread.start;
end;

procedure TFittingForm.MtxThreadProgressUpdate(Sender: TObject;
  Event: TMtxProgressEvent);
begin
  case Event of
  peInit: begin
            MtxThread.DefineProgressBar(ProgressBar);
          end;
  peCycle:begin
            ProgressBar.Position := MtxThread.Counter;
          end;
  peCleanUp:
          begin
            if not MtxThread.Cancel then
            begin
              ProgressBar.Position := MtxThread.Max;
            end;
          end;
  end;
end;

procedure TFittingForm.Gaussian1DClick(Sender: TObject);
begin
   MyFunction.text:='A*exp(-sqr(X-B)/2/sqr(C/2.355))';
end;

procedure TFittingForm.Gaussian2D1Click(Sender: TObject);
begin
   MyFunction.text:='A*exp(-sqr(X-B)/2/sqr(C/2.355))*exp(-sqr(X-D)/2/sqr(E/2.355))';
end;

procedure TFittingForm.Lorentzian1D1Click(Sender: TObject);
begin
    MyFunction.text:='A*C/(sqr(X-B)+sqr(C))';
end;

procedure TFittingForm.xG1xL1Click(Sender: TObject);
begin
   MyFunction.text:='A*exp(-sqr(X-B)/2/sqr(C/2.355))+D*E/(sqr(X-M)+sqr(E))';
end;

procedure TFittingForm.G1G21Click(Sender: TObject);
begin
   MyFunction.text:='A*exp(-sqr(X-B)/2/sqr(C/2.355))+D*exp(-sqr(X-E)/2/sqr(M/2.355))';
end;

procedure TFittingForm.G1G2G31Click(Sender: TObject);
begin
   MyFunction.text:='A*exp(-sqr(X-B)/2/sqr(C/2.355))+D*exp(-sqr(X-E)/2/sqr(M/2.355))+N*exp(-sqr(X-O)/2/sqr(P/2.355))';
end;

{ disque }
{ A = rayon du disque}
{ B = contraste de densit surfacique de longueur de diffusion }
procedure TFittingForm.Disque1Click(Sender: TObject);
begin
   FunctionBox.text:='4*sqr(B*pi*A*A)(A*A*(Qx*Qx+Qy*Qy)+2*(1-cos(sqrt(Qx*Qx+Qy*Qy)*A)-A*sqrt(Qx*Qx+Qy*Qy)*sin(A*sqrt(Qx*Qx+Qy*Qy))))/(sqr(A*A*(Qx*Qx+Qy*Qy)))';
end;

{ cylindre }
{ A = rayon du cylindre}
{ B = contraste de densit volumique de longueur de diffusion }
{ C = longueur du cylindre}
procedure TFittingForm.Cylindre1Click(Sender: TObject);
begin
  FunctionBox.text:='4*sqr(B*pi*A*A*C)*(sqr(sin(C*Qz/2)/(C*Qz/2)))*(A*A*(Qx*Qx+Qy*Qy)+2*(1-cos(sqrt(Qx*Qx+Qy*Qy)*A)-A*sqrt(Qx*Qx+Qy*Qy)*sin(A*sqrt(Qx*Qx+Qy*Qy))))/(sqr(A*A*(Qx*Qx+Qy*Qy)))';
end;

{ sphre }
{ A = rayon de la sphre}
{ B = contraste de densit volumique de longueur de diffusion }
procedure TFittingForm.Sphere1Click(Sender: TObject);
begin
  FunctionBox.text:='sqr(B*4*pi*A*A*A*(sin(A*sqrt(Qx*Qx+Qy*Qy))-A*sqrt(Qx*Qx+Qy*Qy)*cos(A*sqrt(Qx*Qx+Qy*Qy)))/(A*sqrt(Qx*Qx+Qy*Qy)*A*sqrt(Qx*Qx+Qy*Qy)*A*sqrt(Qx*Qx+Qy*Qy)))';
end;

{ ***************************************************************************** }
{ ***************************************************************************** }
{ ***************************************************************************** }

procedure TFittingForm.UpdateUndo;
begin
  istartundo := -1;
  if (Iprevtext <= 0) or (PrevText[Iprevtext - 1] <> ExpressionEdit.Text) then
  begin
    Inc(Iprevtext);
    if Iprevtext >= Nundo then
      Iprevtext := 0;
    PrevText[Iprevtext] := ExpressionEdit.Text;
  end;
end;

procedure TFittingForm.SetUndoText;
begin
  with ExpressionEdit do
  begin
    OnChange := nil;
    Text := PrevText[Iprevtext];
    SelStart := SelStart + Length(Text);
    Sellength := 0;
    OnChange := ExpressionEditChange;
  end;
end;

procedure TFittingForm.AddToEdit(S: string);
var
  Len: Integer;
  IsFunction: Boolean;
begin
  if S = '' then S := ' ';
  with ExpressionEdit do
  begin
    IsFunction := Pos('(', S) > 0;
    Len := Sellength;
    if IsFunction and (Len > 0) then
    begin
      Sellength := 0;
      SelText := Copy(S, 1, Pos('(', S));
      SelStart := SelStart + Len;
      SelText := Copy(S, Pos('(', S) + 1, Len); ;
      SelStart := SelStart - 1;
    end
    else
    begin
      SelText := S;
      if IsFunction then SelStart := SelStart - 1;
    end;
  end;
end;


procedure TFittingForm.Button35Click(Sender: TObject);
begin
  AddToEdit((Sender as TButton).Caption);
end;

procedure TFittingForm.ExpressionEditChange(Sender: TObject);
begin
  UpdateUndo;
end;

procedure TFittingForm.EvaluateClick(Sender: TObject);

  procedure SetEditText(Edit: TEdit; X: TCplx);
  var
    OnCh: TNotifyEvent;
  begin
    OnCh := Edit.OnChange;
    Edit.OnChange := nil;
    Edit.Text := CplxToStr(X);
    Edit.OnChange := OnCh;
  end;
begin
  MyParser.Optimize := OptimizeCheck.Checked;
  MyParser.Add(ExpressionEdit.Text);
  ResultEdit.Text := CplxToStr(MyParser.EvaluateCplx);
  NEvalLabel.Caption := IntToStr(MyParser.ExpressionSize);
  SetEditText(XEdit, X);
  SetEditText(yEdit, Y);
  SetEditText(ZEdit, Z);
end;

procedure TFittingForm.Button35KeyPress(Sender: TObject; var Key: Char);
begin
  ActiveControl := ExpressionEdit;
  with ExpressionEdit do
  begin
    SelStart := SelStart + Sellength;
    Sellength := 0;
  end;
end;

procedure TFittingForm.FunctionsComboChange(Sender: TObject);
var
  S: string;
  I: Integer;
begin
  if (FunctionsCombo.ItemIndex >= 0) and (FunctionsCombo.ItemIndex < Maxstrings) then
  begin
    S := Helpstrings[FunctionsCombo.ItemIndex];
    if MyParser.Separator <> ',' then
      repeat
        I := Pos(',', S);
        if I > 0 then S[I] := MyParser.Separator;
      until I = 0;
    Helplabel.Caption := S;
  end;
end;


procedure TFittingForm.XEditChange(Sender: TObject);
begin
  if XEdit.Text <> '' then X := StrToCplx(XEdit.Text);
end;

procedure TFittingForm.yEditChange(Sender: TObject);
begin
  if YEdit.Text <> '' then Y := StrToCplx(YEdit.Text);
end;

procedure TFittingForm.ZEditChange(Sender: TObject);
begin
  if ZEdit.Text <> '' then Z := StrToCplx(ZEdit.Text)
end;

procedure TFittingForm.MenuItem1Click(Sender: TObject);
begin
  if istartundo = -1 then istartundo := Iprevtext;
  Dec(Iprevtext);
  if Iprevtext < 0 then
    Iprevtext := Nundo - 1;
  SetUndoText;
end;

procedure TFittingForm.MenuItem2Click(Sender: TObject);
begin
  if Iprevtext <> istartundo then
  begin
    Inc(Iprevtext);
    if Iprevtext = Nundo then
      Iprevtext := 0;
  end;
  SetUndoText;
end;

procedure TFittingForm.constantsComboClick(Sender: TObject);
begin
  AddToEdit(ConstantsCombo.Text)
end;

procedure TFittingForm.FormDestroy(Sender: TObject);
begin
  MyParser.Free;
  inherited;
end;

procedure TFittingForm.ExpressionEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  inherited;
  if Key = 13 then EvaluateClick(Sender);
end;

procedure TFittingForm.Button32Click(Sender: TObject);
begin
   AddToEdit(FunctionsCombo.Text);
end;

procedure TFittingForm.Button3Click(Sender: TObject);
begin
   AddToEdit(ConstantsCombo.Text);
end;

procedure TFittingForm.Undo1Click(Sender: TObject);
begin
  if istartundo = -1 then istartundo := Iprevtext;
  Dec(Iprevtext);
  if Iprevtext < 0 then
    Iprevtext := Nundo - 1;
  SetUndoText;
end;

procedure TFittingForm.PopupMenu1Popup(Sender: TObject);
begin
  Undo1.Enabled := (Iprevtext <> -1);
  Redo1.Enabled := (istartundo <> -1) and (istartundo <> Iprevtext);
end;

procedure TFittingForm.Redo1Click(Sender: TObject);
begin
  if Iprevtext <> istartundo then
  begin
    Inc(Iprevtext);
    if Iprevtext = Nundo then
      Iprevtext := 0;
  end;
  SetUndoText;
end;

procedure TFittingForm.Plotdifference1Click(Sender: TObject);
begin
  InitParameters;
  EcartBox.Value:=banana(parsInit,[],[]);
  PlotDiff;
  { update des diffrents graphs }
  sendmessage(principalform.handle,wm_redessine,0,0);
end;

procedure TFittingForm.Calculate1Click(Sender: TObject);
begin
   initparameters;
   banana(parsInit,[],[]);
   case dimSpectrum of
     1:begin plot1D; end;
     2:begin plot2D; end;
   end;
   sendmessage(principalform.handle,wm_redessine,0,0);
end;

procedure TFittingForm.Button4Click(Sender: TObject);
begin
   initparameters;
   generateDistributions(parsInit);
   banana(parsInit,[],[]); { ca sert  initialiser les parametres A,B dans le calcul de la fonction ?!? pas top ! }
   { ci-dessus a changer ! }
   case dimSpectrum of
     1:begin plot1D; end;
     2:begin plot2D; end;
   end;
   sendmessage(principalform.handle,wm_redessine,0,0);
end;


{ plot de la fonction de diffusion dans les axes propores de l'objet            }
{ INPUT : la fonction  plotter (code en soft)                                 }
{         la dimensionnalit                                                    }
{ OUPUT : la figure                                                             }
procedure TFittingForm.Plotformfactoreigenaxis1Click(Sender: TObject);
var i,j,ind,typePlot,k,m,n,p,q:integer;
    R,L,C,Qr,Qz,Qx,Qy:double;
    somme,sommeI,omega,chi:double;
begin
   idlecaption.caption:='Calculating...';idlecaption.update;
   typePlot:=DimRadioGroup.itemindex;  { dimension du plot }
   R:=strtofloat(memoParams.Lines[2]);
   L:=strtofloat(memoParams.Lines[3]);
   C:=strtofloat(memoParams.Lines[4]);

   initparameters2;
   { initialisation des valeurs des parametres }
   omega:=strtofloat(memoParams.Lines[0]);
   chi:=strtofloat(memoParams.Lines[1]);
   R:=strtofloat(memoParams.Lines[2]);
   L:=strtofloat(memoParams.Lines[3]);
   C:=strtofloat(memoParams.Lines[4]);
   GenerateDistributions2(ParsInit);

   if typeplot=0 { 1D en Qr }
   then begin
        { initialisation de la courbe 1D }
        ind:=und.addspectre(DataNameBox.text,NbPtsQrBox.value,1,1); { index du spectre calcul }

        if FlagDistri=false then
        begin
        { remplissage du spectre        }
        for i:=0 to NbPtsQrBox.value-1 do
           begin
              Qr:=IncQrBox.value*(i+1);
              und.spect[ind].data[i,0,0].x:=Qr;
              und.spect[ind].data[i,0,0].y:=0;
              und.spect[ind].data[i,0,0].lt:=0;
              case ObjectType.ItemIndex of
              { sphere } 0:und.spect[ind].data[i,0,0].z:=sqr(C*4*pi*R*R*R*(sin(R*Qr)-R*Qr*cos(R*Qr))/power(R*Qr,3));
              { disque } 1:und.spect[ind].data[i,0,0].z:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr));
{                         2:ShowMessage('Use "Disks" in 1D'); }
              { cylindre}{2:und.spect[ind].data[i,0,0].z:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qr/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr)); }
              end;
           end;
        end

        else
        begin
          for i:=0 to NbPtsQrBox.value-1 do
          begin
              Qr:=IncQrBox.value*(i+1);
              und.spect[ind].data[i,0,0].x:=Qr;
              und.spect[ind].data[i,0,0].y:=0;
              und.spect[ind].data[i,0,0].lt:=0;
              somme:=0;
              { utilisation des distributions                                   }
              for k:=0 to NrPtsDistr[0]-1 do { omega }
                for m:=0 to NrPtsDistr[1]-1 do { chi }
                  for n:=0 to NrPtsDistr[2]-1 do { rayon }
                    for p:=0 to NrPtsDistr[3]-1 do { longueur }
                      for q:=0 to NrPtsDistr[4]-1 do { contraste }
                      begin
                         omega:=DistrX[0,k]*Deg;
                         chi:=DistrX[1,m]*Deg;
                         R:=DistrX[2,n];
                         L:=DistrX[3,p];
                         C:=DistrX[4,q];
                         case ObjectType.ItemIndex of
                         { sphere } 0:sommeI:=sqr(C*4*pi*R*R*R*(sin(R*Qr)-R*Qr*cos(R*Qr))/power(R*Qr,3));
                         { disque } 1:sommeI:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr));
{                                    2:ShowMessage('Use "Disks" in 1D'); }
                         { cylindre}{2:sommeI:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr));}
                         end;
                         somme:=somme+sommeI*DistrInt[0,k]*DistrInt[1,m]*DistrInt[2,n]*DistrInt[3,p]*DistrInt[4,q];
                      end;
                und.spect[ind].data[i,0,0].z:=somme;
              end;
            end;
          end;

   if typeplot=2 { 2D en Qx, Qy }
   then begin
        { initialisation de la courbe 2D }
        ind:=deuxd.addspectre(DataNameBox.text,2*NbPtsQrBox.value+1,2*NbPtsQrBox.value+1,1); { index du spectre calcul }
        if FlagDistri=false then
        begin

        { remplissage du spectre        }
        for i:=0 to 2*NbPtsQrBox.value do
         begin
           Qx:=IncQrBox.value*(i-NbPtsQrBox.value);
           for j:=0 to 2*NbPtsQrBox.value do
             begin
              Qy:=IncQrBox.value*(j-NbPtsQrBox.value);
              deuxd.spect[ind].data[i,j,0].x:=Qx;
              deuxd.spect[ind].data[i,j,0].y:=Qy;
              deuxd.spect[ind].data[i,j,0].lt:=0;
              Qr:=sqrt(Qx*Qx+Qy*Qy);
              case ObjectType.ItemIndex of
              { sphere } 0:deuxd.spect[ind].data[i,j,0].z:=sqr(C*4*pi*R*R*R*(sin(R*Qr)-R*Qr*cos(R*Qr))/power(R*Qr,3));
              { disque } 1:deuxd.spect[ind].data[i,j,0].z:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr));
{                         2:ShowMessage('Use "Disks" in 2D'); }
              { cylindre}{2:deuxd.spect[ind].data[i,j,0].z:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr));}
              end;
             end;
         end
        end

        else
        begin
          for i:=0 to 2*NbPtsQrBox.value do
          begin
            Qx:=IncQrBox.value*(i-NbPtsQrBox.value);
            for j:=0 to 2*NbPtsQrBox.value do
              begin
              Qy:=IncQrBox.value*(j-NbPtsQrBox.value);
              deuxd.spect[ind].data[i,j,0].x:=Qx;
              deuxd.spect[ind].data[i,j,0].y:=Qy;
              deuxd.spect[ind].data[i,j,0].lt:=0;
              somme:=0;
              Qr:=sqrt(Qx*Qx+Qy*Qy);
              { utilisation des distributions                                   }
              for k:=0 to NrPtsDistr[0]-1 do { omega }
                for m:=0 to NrPtsDistr[1]-1 do { chi }
                  for n:=0 to NrPtsDistr[2]-1 do { rayon }
                    for p:=0 to NrPtsDistr[3]-1 do { longueur }
                      for q:=0 to NrPtsDistr[4]-1 do { contraste }
                      begin
                         omega:=DistrX[0,k]*Deg;
                         chi:=DistrX[1,m]*Deg;
                         R:=DistrX[2,n];
                         L:=DistrX[3,p];
                         C:=DistrX[4,q];
                         case ObjectType.ItemIndex of
                         { sphere } 0:sommeI:=sqr(C*4*pi*R*R*R*(sin(R*Qr)-R*Qr*cos(R*Qr))/power(R*Qr,3));
                         { disque } 1:sommeI:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr));
{                                    2:ShowMessage('Use "Disks" in 2D'); }
                         { cylindre}{2:sommeI:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr)); }
                         end;
                         somme:=somme+sommeI*DistrInt[0,k]*DistrInt[1,m]*DistrInt[2,n]*DistrInt[3,p]*DistrInt[4,q];
                      end;
                deuxd.spect[ind].data[i,j,0].z:=somme;
              end;
            end;
          end;
        end;

   idlecaption.caption:='Idle';idlecaption.update;
end;

{ plot de la fonction de diffusion dans les axes du spectro                     }
{ INPUT : la fonction  plotter (code en soft)                                 }
{         la dimensionnalit                                                    }
{ OUPUT : la figure                                                             }
procedure TFittingForm.PlotFormFactordetectorbasis1Click(Sender: TObject);
var i,j,k,m,n,p,q,ind,typePlot:integer;
    R,L,C,Qr,Qz,Qx,Qy,Qxp,Qyp,Qzp,Qrp,Qrps:double;
    chi,omega,somme,sommeI:double;
begin
   idlecaption.caption:='Calculating...';idleCaption.font.color:=clRed;idlecaption.update;
   typePlot:=DimRadioGroup.itemindex;  { dimension du plot }
   initparameters2;
   { initialisation des valeurs des parametres }
   omega:=strtofloat(memoParams.Lines[0]);
   chi:=strtofloat(memoParams.Lines[1]);
   R:=strtofloat(memoParams.Lines[2]);
   L:=strtofloat(memoParams.Lines[3]);
   C:=strtofloat(memoParams.Lines[4]);

   GenerateDistributions2(ParsInit);
   if typeplot=0 { 1D en Qr } { A UPDATER }
   then begin
        { initialisation de la courbe 1D }
        ind:=und.addspectre(DataNameBox.text,NbPtsQrBox.value,1,1); { index du spectre calcul }

        if FlagDistri=false then
        { remplissage du spectre        }
        for i:=0 to NbPtsQrBox.value-1 do
           begin
              Qr:=IncQrBox.value*(i+1);
              und.spect[ind].data[i,0,0].x:=Qr;
              und.spect[ind].data[i,0,0].y:=0;
              und.spect[ind].data[i,0,0].lt:=0;
              case ObjectType.ItemIndex of
              { sphere } 0:und.spect[ind].data[i,0,0].z:=sqr(C*4*pi*R*R*R*(sin(R*Qr)-R*Qr*cos(R*Qr))/power(R*Qr,3));
              { disque } 1:und.spect[ind].data[i,0,0].z:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr));
{                         2:ShowMessage('Tilted cylinders in 1D are ambiguous'); }
              { cylindre}{2:und.spect[ind].data[i,0,0].z:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr));}
              end;
           end
        else ShowMessage('1D spectra with distributions in the detector axis are ambiguous');
        end;

   if typeplot=2 { 2D en Qx, Qy }
   then begin
        { initialisation de la courbe 2D }
        ind:=deuxd.addspectre(DataNameBox.text,2*NbPtsQrBox.value+1,2*NbPtsQrBox.value+1,1); { index du spectre calcul }

        if FlagDistri=false then
        begin
        { remplissage du spectre        }
        Qz:=0;
        for i:=0 to 2*NbPtsQrBox.value do
         begin
           Qx:=IncQrBox.value*(i-NbPtsQrBox.value);
           for j:=0 to 2*NbPtsQrBox.value do
             begin
              Qy:=IncQrBox.value*(j-NbPtsQrBox.value);
              deuxd.spect[ind].data[i,j,0].x:=Qx;
              deuxd.spect[ind].data[i,j,0].y:=Qy;
              deuxd.spect[ind].data[i,j,0].lt:=0;
              { passage dans le rfrentiel du cylindre                         }
              Qxp:=cos(omega)*Qx-sin(omega)*Qz;
              Qyp:=-sin(omega)*sin(chi)*Qx+cos(chi)*Qy-cos(omega)*sin(chi)*Qz;
              Qzp:=sin(omega)*cos(chi)*Qx+sin(chi)*Qy+cos(omega)*cos(chi)*Qz+0.000000001;
              Qrps:=sqrt(Qxp*Qxp+Qyp*Qyp+Qzp*Qzp); { sphere }
              Qrp:=sqrt(Qxp*Qxp+Qyp*Qyp);
              case ObjectType.ItemIndex of
              { sphere } 0:deuxd.spect[ind].data[i,j,0].z:=sqr(C*4*pi*R*R*R*(sin(R*Qrps)-R*Qrps*cos(R*Qrps))/power(R*Qrps,3));
              { disque } 1:deuxd.spect[ind].data[i,j,0].z:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qrp)))/(sqr(R*Qrp));
              { cylindre}2:deuxd.spect[ind].data[i,j,0].z:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qrp)))/(sqr(R*Qrp));
              end;
             end;
           end;
        end
        else
        begin
          Qz:=0;
          progressBar1.max:=2*NbPtsQrBox.value;progressBar1.position:=0;progressBar1.update;
          for i:=0 to 2*NbPtsQrBox.value do
          begin
            Qx:=IncQrBox.value*(i-NbPtsQrBox.value);
            for j:=0 to 2*NbPtsQrBox.value do
              begin
              Qy:=IncQrBox.value*(j-NbPtsQrBox.value);
              deuxd.spect[ind].data[i,j,0].x:=Qx;
              deuxd.spect[ind].data[i,j,0].y:=Qy;
              deuxd.spect[ind].data[i,j,0].lt:=0;
              somme:=0;
              { utilisation des distributions                                   }
              for k:=0 to NrPtsDistr[0]-1 do { omega }
                for m:=0 to NrPtsDistr[1]-1 do { chi }
                  for n:=0 to NrPtsDistr[2]-1 do { rayon }
                    for p:=0 to NrPtsDistr[3]-1 do { longueur }
                      for q:=0 to NrPtsDistr[4]-1 do { contraste }
                      begin
                         omega:=DistrX[0,k]*Deg;
                         chi:=DistrX[1,m]*Deg;
                         R:=DistrX[2,n];
                         L:=DistrX[3,p];
                         C:=DistrX[4,q];
                         { passage dans le rfrentiel du cylindre                         }
                         Qxp:=cos(omega)*Qx-sin(omega)*Qz;
                         Qyp:=-sin(omega)*sin(chi)*Qx+cos(chi)*Qy-cos(omega)*sin(chi)*Qz;
                         Qzp:=sin(omega)*cos(chi)*Qx+sin(chi)*Qy+cos(omega)*cos(chi)*Qz+0.000000001;
                         Qrps:=sqrt(Qxp*Qxp+Qyp*Qyp+Qzp*Qzp); { sphere }
                         Qrp:=sqrt(Qxp*Qxp+Qyp*Qyp);
                         case ObjectType.ItemIndex of
                         { sphere } 0:sommeI:=sqr(C*4*pi*R*R*R*(sin(R*Qrps)-R*Qrps*cos(R*Qrps))/power(R*Qrps,3));
                         { disque } 1:sommeI:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qrp)))/(sqr(R*Qrp));
                         { cylindre}2:sommeI:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qrp)))/(sqr(R*Qrp));
                         end;
                         somme:=somme+sommeI*DistrInt[0,k]*DistrInt[1,m]*DistrInt[2,n]*DistrInt[3,p]*DistrInt[4,q];
                      end;
                deuxd.spect[ind].data[i,j,0].z:=somme;
              end;
            progressBar1.position:=i;progressBar1.update;
            end;
          end;
        end;
    idlecaption.caption:='Idle';idleCaption.font.color:=clGreen;idlecaption.update;
end;


{ procedure d'interpolation                                                     }
{ INPUT : un nom de spectre 1D de reference                                     }
{         le point ou on veut dterminer la valeur                              }
{ OUTPUT : la valeur interpole f(v)                                            }
{ A CORRIGER : cette procedure d'interpolation ne supporte pas que la graduation }
{ des abscisses soit ngative                                                   }
function interpolate(s:string;v:double):double;
var i,ind:integer;
    vmin,vmax,vaux,Iinf,Isup:double;
begin
   ind:=und.indexof(s);
   vmin:=und.spect[ind].data[0,0,0].x;vmax:=und.spect[ind].data[und.spect[ind].X-1,0,0].x;
   if vmax>vmin
   then begin
        i:=0;
        if v<=vmin
        then Result:=und.spect[ind].data[0,0,0].z
        else if v>vmax
             then Result:=und.spect[ind].data[und.spect[ind].X-1,0,0].z
             else begin
             while (und.spect[ind].data[i,0,0].x)<v do inc(i);
             Iinf:=und.spect[ind].data[i-1,0,0].z;Isup:=und.spect[ind].data[i,0,0].z;
             Result:=Iinf+(Isup-Iinf)/(und.spect[ind].data[i,0,0].x-und.spect[ind].data[i-1,0,0].x)*(v-und.spect[ind].data[i-1,0,0].x);
             end;
        end
   else begin { cas ou les abscisses sont dcroissantes }
        vaux:=vmax;vmax:=vmin;vmin:=vaux;
        i:=0;
        if v<=vmin
        then Result:=und.spect[ind].data[und.spect[ind].X-1,0,0].z
        else if v>vmax
             then Result:=und.spect[ind].data[0,0,0].z
             else begin
                  while (und.spect[ind].data[i,0,0].x)>v do inc(i);
                  Iinf:=und.spect[ind].data[i-1,0,0].z;Isup:=und.spect[ind].data[i,0,0].z;
                  Result:=Iinf+(Isup-Iinf)/(und.spect[ind].data[i,0,0].x-und.spect[ind].data[i-1,0,0].x)*(v-und.spect[ind].data[i-1,0,0].x);
             end;
        end
end;


{ plot de la fonction de diffusion F(Q) * S(Q)                                  }
{ INPUT : la fonction  plotter (code en soft)                                 }
{         la dimensionnalit                                                    }
{         le spectre S(Q) (numrique)                                           }
{ OUPUT : la figure                                                             }
procedure TFittingForm.PlotFQxSQ1Click(Sender: TObject);
var i,j,k,m,n,p,q,ind,indS,typePlot:integer;
    R,L,C,Qr,Qz,Qx,Qy,Qxp,Qyp,Qzp,Qrp,Qrps:double;
    chi,omega,somme,sommeI:double;
    Sq:string;
begin
   Sq:=StructureFactorBox.text;

   idlecaption.caption:='Calculating...';idleCaption.color:=clRed;idlecaption.update;
   typePlot:=DimRadioGroup.itemindex;  { dimension du plot }
   initparameters2;
   { initialisation des valeurs des parametres }
   omega:=strtofloat(memoParams.Lines[0]);
   chi:=strtofloat(memoParams.Lines[1]);
   R:=strtofloat(memoParams.Lines[2]);
   L:=strtofloat(memoParams.Lines[3]);
   C:=strtofloat(memoParams.Lines[4]);

   GenerateDistributions2(ParsInit);
   if typeplot=0 { 1D en Qr } { A UPDATER }
   then begin
        { initialisation de la courbe 1D }
        ind:=und.addspectre(DataNameBox.text,NbPtsQrBox.value,1,1); { index du spectre calcul }

        if FlagDistri=false then
        begin
        { remplissage du spectre        }
        for i:=0 to NbPtsQrBox.value-1 do
         begin
              Qr:=IncQrBox.value*(i-NbPtsQrBox.value);
              und.spect[ind].data[i,0,0].x:=Qr;
              und.spect[ind].data[i,0,0].y:=0;
              und.spect[ind].data[i,0,0].lt:=0;
              case ObjectType.ItemIndex of
              { sphere } 0:und.spect[ind].data[i,0,0].z:=sqr(C*4*pi*R*R*R*(sin(R*Qr)-R*Qr*cos(R*Qr))/power(R*Qr,3))*Interpolate(Sq,Qr);
              { disque } 1:und.spect[ind].data[i,0,0].z:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr))*Interpolate(Sq,Qr);
{                         2:ShowMessage('Use "Disks" in 1D'); }
              { cylindre}{2:und.spect[ind].data[i,j,0].z:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qz)))/(sqr(R*Qz))*Interpolate(Sq,Qz);}
              end;
         end
        end
        else
        begin
          for i:=0 to NbPtsQrBox.value-1 do
          begin
              Qr:=IncQrBox.value*(i-NbPtsQrBox.value);
              und.spect[ind].data[i,0,0].x:=Qr;
              und.spect[ind].data[i,0,0].y:=0;
              und.spect[ind].data[i,0,0].lt:=0;
              somme:=0;
              { utilisation des distributions                                   }
              for k:=0 to NrPtsDistr[0]-1 do { omega }
                for m:=0 to NrPtsDistr[1]-1 do { chi }
                  for n:=0 to NrPtsDistr[2]-1 do { rayon }
                    for p:=0 to NrPtsDistr[3]-1 do { longueur }
                      for q:=0 to NrPtsDistr[4]-1 do { contraste }
                      begin
                         omega:=DistrX[0,k]*Deg;
                         chi:=DistrX[1,m]*Deg;
                         R:=DistrX[2,n];
                         L:=DistrX[3,p];
                         C:=DistrX[4,q];
                         case ObjectType.ItemIndex of
                         { sphere } 0:sommeI:=sqr(C*4*pi*R*R*R*(sin(R*Qr)-R*Qr*cos(R*Qr))/power(R*Qr,3))*Interpolate(Sq,Qr);
                         { disque } 1:sommeI:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qr)))/(sqr(R*Qr))*Interpolate(Sq,Qr);
{                                    2:ShowMessage('Use "Disks" in 1D'); }
                         { cylindre}{2:sommeI:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qz)))/(sqr(R*Qz))*Interpolate(Sq,Qz); }
                         end;
                         somme:=somme+sommeI*DistrInt[0,k]*DistrInt[1,m]*DistrInt[2,n]*DistrInt[3,p]*DistrInt[4,q];
                      end;
                und.spect[ind].data[i,0,0].z:=somme;
          end;
        end;
        end;

   if typeplot=2 { 2D en Qx, Qy }
   then begin
        { initialisation de la courbe 2D }
        ind:=deuxd.addspectre(DataNameBox.text,2*NbPtsQrBox.value+1,2*NbPtsQrBox.value+1,1); { index du spectre calcul }

        if FlagDistri=false then
        begin
        { remplissage du spectre        }
        Qz:=0;
        for i:=0 to 2*NbPtsQrBox.value do
         begin
           Qx:=IncQrBox.value*(i-NbPtsQrBox.value);
           for j:=0 to 2*NbPtsQrBox.value do
             begin
              Qy:=IncQrBox.value*(j-NbPtsQrBox.value);
              deuxd.spect[ind].data[i,j,0].x:=Qx;
              deuxd.spect[ind].data[i,j,0].y:=Qy;
              deuxd.spect[ind].data[i,j,0].lt:=0;
              { passage dans le rfrentiel du cylindre                         }
              Qxp:=cos(omega)*Qx-sin(omega)*Qz;
              Qyp:=-sin(omega)*sin(chi)*Qx+cos(chi)*Qy-cos(omega)*sin(chi)*Qz;
              Qzp:=sin(omega)*cos(chi)*Qx+sin(chi)*Qy+cos(omega)*cos(chi)*Qz+0.000000001;
              Qrps:=sqrt(Qxp*Qxp+Qyp*Qyp+Qzp*Qzp); { sphere }
              Qrp:=sqrt(Qxp*Qxp+Qyp*Qyp);
              case ObjectType.ItemIndex of
              { sphere } 0:deuxd.spect[ind].data[i,j,0].z:=sqr(C*4*pi*R*R*R*(sin(R*Qrps)-R*Qrps*cos(R*Qrps))/power(R*Qrps,3))*Interpolate(Sq,Qrps);
              { disque } 1:deuxd.spect[ind].data[i,j,0].z:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qrp)))/(sqr(R*Qrp))*Interpolate(Sq,Qrp);
              { cylindre}2:deuxd.spect[ind].data[i,j,0].z:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qrp)))/(sqr(R*Qrp))*Interpolate(Sq,Qrp);
              end;
             end;
           end;
        end
        else
        begin
          Qz:=0;
          for i:=0 to 2*NbPtsQrBox.value do
          begin
            Qx:=IncQrBox.value*(i-NbPtsQrBox.value);
            for j:=0 to 2*NbPtsQrBox.value do
              begin
              Qy:=IncQrBox.value*(j-NbPtsQrBox.value);
              deuxd.spect[ind].data[i,j,0].x:=Qx;
              deuxd.spect[ind].data[i,j,0].y:=Qy;
              deuxd.spect[ind].data[i,j,0].lt:=0;
              somme:=0;
              { utilisation des distributions                                   }
              for k:=0 to NrPtsDistr[0]-1 do { omega }
                for m:=0 to NrPtsDistr[1]-1 do { chi }
                  for n:=0 to NrPtsDistr[2]-1 do { rayon }
                    for p:=0 to NrPtsDistr[3]-1 do { longueur }
                      for q:=0 to NrPtsDistr[4]-1 do { contraste }
                      begin
                         omega:=DistrX[0,k]*Deg;
                         chi:=DistrX[1,m]*Deg;
                         R:=DistrX[2,n];
                         L:=DistrX[3,p];
                         C:=DistrX[4,q];
                         { passage dans le rfrentiel du cylindre                         }
                         Qxp:=cos(omega)*Qx-sin(omega)*Qz;
                         Qyp:=-sin(omega)*sin(chi)*Qx+cos(chi)*Qy-cos(omega)*sin(chi)*Qz;
                         Qzp:=sin(omega)*cos(chi)*Qx+sin(chi)*Qy+cos(omega)*cos(chi)*Qz+0.000000001;
                         Qrps:=sqrt(Qxp*Qxp+Qyp*Qyp+Qzp*Qzp); { sphere }
                         Qrp:=sqrt(Qxp*Qxp+Qyp*Qyp);
                         case ObjectType.ItemIndex of
                         { sphere } 0:sommeI:=sqr(C*4*pi*R*R*R*(sin(R*Qrps)-R*Qrps*cos(R*Qrps))/power(R*Qrps,3))*Interpolate(Sq,Qrp);
                         { disque } 1:sommeI:=4*sqr(C*pi*R*R)*sqr(Cabs(BesJ(1,R*Qrp)))/(sqr(R*Qrp))*Interpolate(Sq,Qrp);
                         { cylindre}2:sommeI:=4*sqr(C*pi*R*R*L)*(sqr(sin(L*Qzp/2)/(L*Qzp/2)))*sqr(Cabs(BesJ(1,R*Qrp)))/(sqr(R*Qrp))*Interpolate(Sq,Qrp);
                         end;
                         somme:=somme+sommeI*DistrInt[0,k]*DistrInt[1,m]*DistrInt[2,n]*DistrInt[3,p]*DistrInt[4,q];
                      end;
                deuxd.spect[ind].data[i,j,0].z:=somme;
              end;
            end;
          end;
        end;
    idlecaption.caption:='Idle';idleCaption.color:=clGreen;idlecaption.update;
end;


{ calcul de l'intensit rflchie par les parois internes/externes d'un cylindre }
procedure TFittingForm.Reflectioninsideacylinder1Click(Sender: TObject);
var i:integer;
    nbFacettes:integer;
    n0,n1:double;
    R,T:array of double; { intensits rflchies et tarnsmises pour chaque facette }
begin
   { nombre de facettes pour approcimer le cylindre                             }
   NbFacettes:=NbFacettesBox.value;
   setlength(R,NbFacettes);setlength(T,NbFacettes);
   n0:=n0Box.value;n1:=n1Box.value; { optical index of the matrix and of the material in the cylinder }
   { as start, we make the assumption that the cylinders are empty }

   { calcul des amplitudes transmises et rflchies pour chaque facette }
   for i:=0 to NbFacettes-1 do
   begin
      { dtermination de l'angle d'incidence du faisceau sur la facette }
      { dfinition du vecteur directeur normal  la facette       }
      { vecteur directeur du faisceau incident                  }

   end;
end;

function Norm(u:vecteur):double;
var a:double;
begin
  result:=sqrt(sqr(u.x)+sqr(u.y)+sqr(u.z));
end;
function Normalize(u:vecteur):vecteur;
var a:double;
begin
  a:=sqrt(sqr(u.x)+sqr(u.y)+sqr(u.z));
  u.x:=u.x/a;u.y:=u.y/a;u.z:=u.z/a;
  result:=u;
end;
function Dot(u,v:vecteur):double;
begin
  result:=u.x*v.x+u.y*v.y+u.z*v.z;
end;
function Cross(u,v:vecteur):vecteur;
begin
  result.x:=u.y*v.z-u.z*v.y;
  result.y:=u.z*v.x-u.x*v.z;
  result.z:=u.x*v.y-u.y*v.x;
end;

{ rflxion sur un dioptre d'orientation quelconque       }
{ INPUT : k vecteur incident sur le dioptre              }
{         n vecteur noraml  la surface du dioptre       }
{         indice : indice optique du dioptre             }
{ OUTPUT : la rflectivit                               }
function ReflexionDioptre(k:vecteur;n:vecteur;indice:double):double;
begin

end;

{ calcul de la reflexion  l'intrieur d'un tube                                }
{ introduire la correction d'clairement                                        }
{ A FAIRE                                                                       }
{ * je ne comprends pas ma coupure entre la partie totalement rflchie et      }
{   la partie seulement partiellement rflchie                                 }
{   Est-ce un problme d'clairement ?                                          }
{ * le vecteur d'onde de l'onde refrcate est FAUX !!!                         }
{   la version actuelle fait tout pointer vers 0 pour T                         }
procedure TFittingForm.CalcRefButtonClick(sender: TObject);
var i,j,ind,indR,indT,NbPtsQ,x,y,d0,d1:integer;
    Qstep,qx,qy,omega,chi,lambda:double;
    d,u,v,ki,kr,kt,n,s,p:vecteur;
    indice,q0,p0,k0,k1,q1,R,T,theta,aux,sinTi:double;
    NbFaces:integer;
    surf,Diam,Long,Dens:double;
begin
   initparameters2;
   GenerateDistributions2(ParsInit);
   indice:=1-n0box.value*1e-6;
   omega:=strtofloat(memoParams.Lines[0])*pi/180;
   chi:=strtofloat(memoParams.Lines[1])*pi/180;
   Diam:=2*strtofloat(memoParams.Lines[2])*1e-9;
   Long:=strtofloat(memoParams.Lines[3])*1e-9;
   Dens:=TubesDensityBox.value*1e12;

   lambda:=strtofloat(memoParams.Lines[6]);
   thetaclabel.caption:=floatToSTr(arccos(indice)*180/pi);
   NbFaces:=NbFacettesBox.value;
   NbPtsQ:=NbPtsQrBox.value;
   Qstep:=IncQrBox.value;
   ind:=deuxd.addspectre(dataNameBox.text,2*NbPtsQ+1,2*NbPtsQ+1,1); { spectre de stockage de la rflectivit }
   indR:=deuxd.addspectre(dataNameBox.text+'_R',2*NbPtsQ+1,2*NbPtsQ+1,1); { spectre de stockage de la rflectivit }
   indT:=deuxd.addspectre(dataNameBox.text+'_T',2*NbPtsQ+1,2*NbPtsQ+1,1); { spectre de stockage de la rflectivit }
   for i:=0 to 2*NbPtsQ do
     for j:=0 to 2*NbPtsQ do
       begin deuxd.spect[ind].data[i,j,0].x:=(i-NbPtsQ)*Qstep;
             deuxd.spect[ind].data[i,j,0].y:=(j-NbPtsQ)*Qstep;
             deuxd.spect[indR].data[i,j,0].x:=(i-NbPtsQ)*Qstep;
             deuxd.spect[indR].data[i,j,0].y:=(j-NbPtsQ)*Qstep;
             deuxd.spect[indT].data[i,j,0].x:=(i-NbPtsQ)*Qstep;
             deuxd.spect[indT].data[i,j,0].y:=(j-NbPtsQ)*Qstep; end;

   { vecteur d'onde incident }
   k0:=2*pi/lambda;
   ki.x:=0;ki.y:=0;ki.z:=k0; { le long de l'axe Oz pour le moment }

surf:=Long*pi*Diam/NbFaces*Dens; { surface d'une facette * densit de tubes par m}
progressBar1.max:=NrPtsDistr[0];
for d0:=0 to NrPtsDistr[0]-1 do { omega }
begin
  for d1:=0 to NrPtsDistr[1]-1 do { chi }
  begin
   omega:=DistrX[0,d0]*Deg; { passage en radians }
   chi:=DistrX[1,d1]*Deg;
   { soit d le vecteur directeur du tube }
   d.x:=sin(omega)*cos(chi);d.y:=sin(chi);d.z:=cos(omega)*cos(chi);
   { u et v 2 vecteurs orthogonaux de la base du tube }
   { avec u plus ou moins dans la direction X }
   u.x:=d.z;u.y:=0;u.z:=-d.x;
   v:=cross(d,u);
   for i:=0 to NbFaces-1 do
   begin
      theta:=i*2*Pi/NbFaces; { theta:=(tmin.value+i*(tmax.value-tmin.value)/NbFaces)*Pi/180; }
      { vecteur directeur de la faces en cours } { le vecteur point vers le cenre du tube }
      n.x:=-cos(theta)*u.x-sin(theta)*v.x;
      n.y:=-cos(theta)*u.y-sin(theta)*v.y;
      n.z:=-cos(theta)*u.z-sin(theta)*v.z;
      s:=normalize(cross(n,ki));p:=normalize(cross(s,n));
      { calcul de la rflectivit }
      q0:=dot(ki,n); { composante du vecteur d'onde perpendiculaire  la surface }
      { par quel cot du dioptre arrive-t-on ? }
     if q0<0 then
     begin { on va du vide vers l'alumine, donc on peut se rflchir }
      q0:=abs(q0);
{      p0:=norm(cross(n,ki));  { composante du vecteur d'onde parallle  la surface }
      p0:=dot(ki,p);
      k1:=indice*k0; { vecteur d'onde dans la matrice }
      { eclairement } sinTi:=q0/k0; { sinus de l'angle d'incidence }
      aux:=sqr(k1)-sqr(p0);
      if aux<0
      then begin { en-dessous de l'angle critique, la direction de T est parallle  la surface }
           R:=1*sinTi*surf;T:=sqr(2*q0)/(sqr(q0)+abs(aux))*sinTi*surf;
           { direction du vecteur d'onde refract }
           kt.x:=k1*p.x;  kt.y:=k1*p.y;  kt.z:=k1*p.z;
           end
      else begin { au-dessus de l'angle critique, l'intensit transmise est rfracte      }
           q1:=sqrt(aux);
           R:=sqr((q0-q1)/(q0+q1))*sinTi*Surf;
           T:=sqr(2*q0/(q0+q1))*sinTi*Surf;
           { direction du vecteur d'onde refract }
           kt.x:= -q1*n.x + p0*p.x;
           kt.y:= -q1*n.y + p0*p.y;
           kt.z:= -q1*n.z + p0*p.z;
           end;
      { direction du vecteur d'onde rflchi }
      kr.x:= q0*n.x + p0*p.x;
      kr.y:= q0*n.y + p0*p.y;
      kr.z:= q0*n.z + p0*p.z;
      { projection de kr sur le compteur }
      qx:=kr.x;qy:=kr.y;x:=round((qx/Qstep)+NbPtsQ);y:=round((qy/Qstep)+NbPtsQ);
      if (x>=0) and (y>=0) and (x<deuxd.spect[indR].X) and (y<deuxd.spect[indR].Y)
      then deuxd.spect[indR].data[x,y,0].z:=deuxd.spect[indR].data[x,y,0].z+R*DistrInt[0,d0]*DistrInt[1,d1];
      { projection de kt sur le compteur }
      qx:=kt.x;qy:=kt.y;x:=round((qx/Qstep)+NbPtsQ);y:=round((qy/Qstep)+NbPtsQ);
      if (x>=0) and (y>=0) and (x<deuxd.spect[indT].X) and (y<deuxd.spect[indT].Y)
      then deuxd.spect[indT].data[x,y,0].z:=deuxd.spect[indT].data[x,y,0].z+T*DistrInt[0,d0]*DistrInt[1,d1];
     end
   end;
  end;
progressBar1.Position:=d0+1;progressBar1.update;
end;
  
  for i:=0 to 2*NbPtsQ do
    for j:=0 to 2*NbPtsQ do
    begin
      deuxd.spect[indR].data[i,j,0].z:=deuxd.spect[indR].data[i,j,0].z*1e0; { 1e6 est arbitraire }
      deuxd.spect[indT].data[i,j,0].z:=deuxd.spect[indT].data[i,j,0].z*1e0;
      deuxd.spect[ind].data[i,j,0].z:=deuxd.spect[indR].data[i,j,0].z+deuxd.spect[indT].data[i,j,0].z;
    end;
end;

initialization
  RegisterClass(TFittingForm);

end.


