unit PilotageSMAC;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CPort, CPortCtl, Menus, JvComponent, Spin, EditReal,
  ComCtrls,EditData;

type                                   
  TPilotageSMACform = class(TForm)
    ComPort: TComPort;
    MainMenu1: TMainMenu;
    FIle1: TMenuItem;
    RS2321: TMenuItem;
    Open1: TMenuItem;
    Settings1: TMenuItem;
    Load1: TMenuItem;
    Savesettings1: TMenuItem;
    Sendnewline1: TMenuItem;
    SMAC1: TMenuItem;
    N1: TMenuItem;
    SendTextfile1: TMenuItem;
    CaptureTextFile1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Commands1: TMenuItem;
    ellMacroCTRLM1: TMenuItem;
    ellConstants1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    Button1: TButton;
    TrajectoryBox: TEdit;
    Memo: TMemo;
    Panel2: TPanel;
    Edit_Data: TEdit;
    Button_Send: TButton;
    NbPointsBox: TEditReal;
    Button2: TButton;
    TabSheet2: TTabSheet;
    Panel3: TPanel;
    SaveSMACsettings1: TMenuItem;
    Memo1: TMemo;
    MemoSettings: TMemo;
    Initparameters1: TMenuItem;
    Button3: TButton;
    TimerTraj: TTimer;
    Label2: TLabel;
    Panel4: TPanel;
    Label3: TLabel;
    RecRateMultBox: TSpinEdit;
    TestButton: TButton;
    procedure Button_SettingsClick(Sender: TObject);
    procedure Button_SendClick(Sender: TObject);
    procedure ComPortRxChar(Sender: TObject; Count: Integer);
    procedure Bt_LoadClick(Sender: TObject);
    procedure Bt_StoreClick(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Savesettings1Click(Sender: TObject);
    procedure Sendnewline1Click(Sender: TObject);
    procedure Edit_DataKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SendTextfile1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Initparameters1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ellMacroCTRLM1Click(Sender: TObject);
    procedure ellConstants1Click(Sender: TObject);
    procedure TimerTrajTimer(Sender: TObject);
    procedure TestButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PilotageSMACform: TPilotageSMACform;
  NbPtsTraj:integer;
  indTraj:integer; { indice du spectre de trajectoire }

implementation

{$R *.DFM}

procedure delay(temps:double);
var t0,t:real;
begin
   t0:=(time-int(time))*86400;  {temps en s}
   repeat
     t:=(time-int(time))*86400;
     if t<t0 then t:=t+86400;  {correction bug passage par minuit}
   until ((t-t0)>temps);
end;

procedure TPilotageSMACform.Button_SettingsClick(Sender: TObject);
begin
  ComPort.ShowSetupDialog;
end;

procedure TPilotageSMACform.Button_SendClick(Sender: TObject);
var Str: String;
begin
  Str := Edit_Data.Text;
{  if NewLine_CB.Checked then Str := Str + #13#10; }
  if SendNewLine1.Checked then Str := Str + #13#10;
  ComPort.WriteStr(Str);
  Edit_Data.Text:='';
end;

procedure TPilotageSMACform.ComPortRxChar(Sender: TObject; Count: Integer);
var Str: String;
    i,pos:integer;
begin
  ComPort.ReadStr(Str, Count);
  Memo.Text := Memo.Text + Str;
{  memo.lines.add(str); } { ca traite pas automatiquemeny les caracteres de controles }
{  Memo.selstart:=length(memo.text)-1; { ca ne sert a rien ?! }
{  Memo.ScrollBy(0,-100); { marche pas }
end;

procedure TPilotageSMACform.Bt_LoadClick(Sender: TObject);
begin
  ComPort.LoadSettings(stRegistry, 'HKEY_LOCAL_MACHINE\Software\Dejan');
//  ComPort.LoadSettings(stIniFile, 'e:\Test.ini');
end;

procedure TPilotageSMACform.Bt_StoreClick(Sender: TObject);
begin
//  ComPort.StoreSettings(stIniFile, 'e:\Test.ini');
  ComPort.StoreSettings(stRegistry, 'HKEY_LOCAL_MACHINE\Software\Dejan');
end;

procedure TPilotageSMACform.Settings1Click(Sender: TObject);
begin
  ComPort.ShowSetupDialog;
end;

procedure TPilotageSMACform.Open1Click(Sender: TObject);
begin
  if ComPort.Connected
  then begin ComPort.Close;open1.caption:='Open';label1.Caption:='Disconnected';label1.font.color:=clSilver end
  else begin ComPort.Open;open1.caption:='Close';label1.Caption:='Connected';label1.font.color:=clRed end;
end;

procedure TPilotageSMACform.Load1Click(Sender: TObject);
begin
  ComPort.LoadSettings(stRegistry, 'HKEY_LOCAL_MACHINE\Software\Dejan');
//  ComPort.LoadSettings(stIniFile, 'e:\Test.ini');
end;

procedure TPilotageSMACform.Savesettings1Click(Sender: TObject);
begin
//  ComPort.StoreSettings(stIniFile, 'e:\Test.ini');
  ComPort.StoreSettings(stRegistry, 'HKEY_LOCAL_MACHINE\Software\Dejan');
end;

procedure TPilotageSMACform.Sendnewline1Click(Sender: TObject);
begin
  if SendNewLine1.Checked
  then SendNewLine1.Checked:=false
  else SendNewLine1.Checked:=true;
end;


procedure TPilotageSMACform.Edit_DataKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
   { on envoie un ESC }
   if key=27 then ComPort.WriteStr(chr(27));
end;

procedure TPilotageSMACform.SendTextfile1Click(Sender: TObject);
var F: TextFile;
    S: string;
begin
  if OpenDialog1.Execute then            { Affichage de la bote de dialogue d'ouverture }
  begin
    AssignFile(F, OpenDialog1.FileName); { Fichier slectionn dans la bote de dialogue }
    Reset(F);
    while not(EOF(f)) do
    begin
      Readln(F, S);                      { Lecture de la premire ligne du fichier }
      ComPort.WriteStr(s+#13#10);       { Introduction de la chane dans un contrle TEdit }
      delay(0.1);
    end;
    CloseFile(F);
  end;
end;

procedure TPilotageSMACform.Button1Click(Sender: TObject);
begin
  label2.caption:='Reading';label2.color:=clRed;
  memo.clear;
  NbPtsTraj:=round(NbPointsBox.value);
  indTraj:=und.addSPectre(TrajectoryBox.text,NbPtsTraj,1,1);
  ComPort.WriteStr('DD'+IntToStr(NbPtsTraj)+#13#10);
  TimerTraj.enabled:=true;
end;

{ on arrete tout ; boutton STOP }
procedure TPilotageSMACform.Button2Click(Sender: TObject);
begin
  ComPort.WriteStr('MF'+#13#10);
end;

{ entre des paramtres di'nitialisation }
procedure TPilotageSMACform.Initparameters1Click(Sender: TObject);
var i:integer;
    s:string;
begin
  { avant de changer les paramtres, on arrete le SMAC }
  ComPort.WriteStr('MF'+#13#10);
  { envoie des paramtres de configuration }
  for i:=0 to memoSettings.lines.count-1 do
  begin
     s:=MemoSettings.lines[i];
     ComPort.WriteStr(s+#13#10);       { Introduction de la chane dans un contrle TEdit }
     delay(0.1);
  end;
end;

procedure TPilotageSMACform.Button3Click(Sender: TObject);
begin
  Memo.Clear;
end;

procedure TPilotageSMACform.ellMacroCTRLM1Click(Sender: TObject);
begin
  Memo.Clear;
  ComPort.WriteStr('TM-1'+#13#10);
end;

procedure TPilotageSMACform.ellConstants1Click(Sender: TObject);
begin
  Memo.Clear;
  ComPort.WriteStr('TK'+#13#10);
end;

{ stockage de la trajectoire mesure lorsque les data ont t rcupres        }
procedure TPilotageSMACform.TimerTrajTimer(Sender: TObject);
var i,pos,RecRate:integer;
    s:string;
begin
   if Memo.lines.count>(NbPtsTraj+1)
   then begin
        RecRate:=RecRateMultBox.value;
        for i:=1 to Memo.lines.count-2 do
        begin
          s:=Memo.lines[i];pos:=StrToInt(s);
          und.spect[indTraj].data[i-1,0,0].X:=(i-1)*RecRate*0.2; { 200s d'horloge }
          und.spect[indTraj].data[i-1,0,0].Z:=pos;
        end;
        TimerTraj.enabled:=false;
        label2.caption:='Finished';label2.color:=clBtnFace;
        end;
end;


procedure TPilotageSMACform.TestButtonClick(Sender: TObject);
begin
{  memo.lines.add(str); } { ca traite pas automatiquemeny les caracteres de controles }
{  Memo.selstart:=length(memo.text)-1; { ca ne sert a rien ?! }
  Memo.ScrollBy(0,-1000); { marche pas }
end;

procedure TPilotageSMACform.FormCreate(Sender: TObject);
begin
  left:=0;top:=0;width:=467;height:=500;
  WindowState:=wsMinimized;
end;

end.
